<?php

include_once(__DIR__ . "/../../../fonctions/authplugins.php");

include_once(__DIR__ . "/../../../classes/Client.class.php");

require_once(__DIR__ . '/Mailjetlite.class.php');

class MailjetliteAdmin extends Mailjetlite
{
	private $last_message = '';

	public function __construct() {

		autorisation(self::MODULE);

		parent::__construct();
	}

	private function update_config() {
		foreach($_REQUEST as $var => $value)
		{
			if (! preg_match('/^'.self::PREFIXE.'/', $var)) continue;

			Variable::ecrire($var, trim($value), true, 1, 1);
		}
	}

	private function import_base_clients($idliste) {

		if (intval($idliste) > 0) {
			$hdl = $this->query("select email from ".Client::TABLE." order by email asc");

			$contacts = array();

			while ($hdl && $row = $this->fetch_object($hdl)) {
				$contacts[] =  $row->email;
			}

			# Parameters
			$params = array(
				'method' => 'POST',
				'contacts' => implode(',', $contacts),
				'id' => $idliste
			);

			$response = $this->get_mj()->listsAddManyContacts($params);

			if ($response && $response->status == 'OK') {
				$this->last_message = count($contacts) . " emails importés.";
			}
			else if ($this->get_mj()->_response_code == 304) {
				$this->last_message = "Vos clients figurent déjà dans cette liste.";
			}
			else {
				$this->last_message = "L'importation de ".count($contacts)." emails a échoué (code ".$this->get_mj()->_response_code.")";
			}
		}
	}

	public function exec() {
		$commande = lireParam('commande');

			if ($commande == 'maj_config') {

			$this->update_config();
		}
		else if ($commande == 'importer') {

			$this->import_base_clients(lireParam('idliste'));
		}

		return $this->html();
	}

	private function check() {
		return $this->get_mj()->userInfos();
	}

    public function html() {
	?>
		<div id="bloc_description">

			<div class="entete">
				<div class="titre">CONFIGURATION MAILJET</div>
				<div class="fonction_valider"><a href="#" onclick="$('#<?php echo self::PREFIXE ?>form').submit(); return false;">VALIDER LES MODIFICATIONS</a></div>
			</div>

	        <form method="post" action="<?php echo $_SERVER['PHP_SELF'] ?>" id="<?php echo self::PREFIXE ?>form">

	        <input type="hidden" name="nom" value="<?php echo self::MODULE ?>" />
	        <input type="hidden" name="commande" id="commande" value="maj_config" />

			 	<table width="100%" cellpadding="5" cellspacing="0">
		       	    <tr class="fonce">
		                <td colspan="2">
		                <p>Merci d'indiquer ici les informations qui permettront à Thelia d'accéder à l'API Mailjet.</p>
						<p>Vous trouverez les informations demandées dans votre compte Mailjet, rubrique "REST API", puis cliquez sur
						<a href="https://fr.mailjet.com/account/api_keys">Clé API principale</a>.</p>
		                </td>
		       	    </tr>

				 	<tr class="claire">
						<td class="designation">Clef API</td>
						<td><input type="text" size="60" name="<?php echo self::VAR_CLEF_API ?>" value="<?php echo htmlspecialchars(Variable::lire(self::VAR_CLEF_API)); ?>" /></td>
					</tr>

				 	<tr class="fonce">
						<td class="designation">Clef secrète</td>
						<td><input type="text" size="60" name="<?php echo self::VAR_CLEF_SECRETE ?>" value="<?php echo htmlspecialchars(Variable::lire(self::VAR_CLEF_SECRETE)); ?>" /></td>
					</tr>

				 	<tr class="claire">
						<td class="designation">Informations de deboguage</td>
						<td>
							<?php
							$curr = intval(Variable::lire(self::VAR_DEBUG_ON));
							$vals = array(
								"0" => 'Aucune',
								"1" => 'Erreurs seulement',
								"2" => 'Complètes',
							)
							?>
							<select name="<?php echo self::VAR_DEBUG_ON ?>">
								<?php
								foreach($vals as $val => $label) {
								?>
									<option value="<?php echo $val ?>"<?php if ($val == $curr) echo ' selected="selected"'; ?>><?php echo $label ?></option>
								<?php } ?>
							</select>
						</td>
					</tr>

					<tr class="fonce lignebottom">
						<td class="designation">Contrôle</td>
						<td>
						<?php
						if ($this->check() !== false) {
							?>
							<p style="color: #468847">Connexion à Mailjet OK !</p>
							<?php
    					}
						else {
							?>
							<p style="color: #F89406">Echec de connexion à Mailjet. Les clefs indiquées sont sans doute incorrectes.</p>
							<?php
						}
						?>
						</td>
					</tr>
				</table>
			</form>

			<?php
			$lists = $this->get_lists();

			if ($lists && count($lists) > 0) {
				?>

				<div class="entete">
					<div class="titre">IMPORTATION DE VOS CLIENTS</div>
					<div class="fonction_valider"><a href="#" onclick="$('#<?php echo self::PREFIXE ?>form2').submit(); return false;">IMPORTER</a></div>
				</div>

		        <form method="post" action="<?php echo $_SERVER['PHP_SELF'] ?>" id="<?php echo self::PREFIXE ?>form2">

			        <input type="hidden" name="nom" value="<?php echo self::MODULE ?>" />
			        <input type="hidden" name="commande" id="commande" value="importer" />

				 	<table width="100%" cellpadding="5" cellspacing="0">

				 		<tr class="fonce">
					 		<td colspan="2">
					 		Cette fonction vous permet d'importer tous les emails de vos clients dans une de vos listes Mailjet. Choisissez
					 		la liste où importer ci-dessous, puis cliquez "IMPORTER".
					 		</td>
				 		</tr>

					 	<tr class="claire">
							<td class="designation">Importer dans la liste:</td>
							<td>
								<select name="idliste">
									<?php
									foreach($lists as $liste) {
									?>
										<option value="<?php echo $liste->id ?>"><?php echo $liste->label ?></option>
									<?php } ?>
								</select>
							</td>
						</tr>
					 	<tr class="foncebottom">
					 		<td colspan="2">
					 		<?php if (! empty($this->last_message)) { ?>
					 		<p><strong>Résultat</strong>: <?php echo $this->last_message ?></p>
					 		<?php } ?>
					 		</td>
					 	</tr>
					</table>
		        </form>
				<?php
			}
			?>

		</div>

		<p style="clear: both; margin-top: 30px;color:#505050;font-size:9px;text-align:left;">Plugin Thelia réalisé par <a href="http://www.cqfdev.fr" target="_blank">Franck Allimant / CQFDev</a>. Contact: <a href="http://www.cqfdev.fr" target="_blank">www.cqfdev.fr</a> - +33(0)6.62.38.28.69</p>
	<?php
    }
}
?>